// ====================================================================
// csaMainlib.js: Web client-side basic functions for CSA.
//
// Copyright (c) 2006 Carlo Strozzi
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 dated June, 1991.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// ====================================================================
// $Id$

// ====================================================================
// Function definitions
// =====================================================================

// =====================================================================
// void csaDumpResult(string url)
//
// Print the result of a CSA-RPC call.
// =====================================================================

function csaDumpResult(url) {

  var i = 0;
  var j = 0;
  var result = "";
  var result1 = "";
  var name = "";
  var value = "";
  var out = "RDF results from URL:\n" + url

  result = _RDF.Match(null,url+"#response");

  for (i=0; i < result.length; i++) {
     name = result[i].object.replace(/#response\./,"");
     result1 = _RDF.Match(null,result[i].object);

     out = out + "\n----------------------------------------------\n";

     //out = out + result1.toNTriples() + "\n";

     if (name.match) name = "\"" + name + "\"";

     for (j=1; j < result1.length; j++) {
	 value = _RDF.getSingleObject(result1,null,_XMLNS_RDF+"_"+j);
	 if (value.match)
		value = "\"" + value.replace(/"/g,"\"") + "\"";
	 out = out + "\nresult["+name+","+j+"] = "+value;
     }

     //sample code to jumps to the last URL returned.
     //document.location = _RDF.getSingleObject(result1,null,_XMLNS_RDF+"_"+(j-1));
  };

  alert(out);

  _RDF = new RDF();				// clear on return !
}

// =====================================================================
// void csaViewSource(void)
//
// Show source of the current Web page.
// =====================================================================

function csaViewSource() {
   // made by: Nicolas - http://www.javascript-page.com
   // modifyed by: Carlo Strozzi
   document.location = "view-source:" + document.location.href
}

// =====================================================================
// void csaToggleVisibility(string element)
//
// Toggle Web page element visibility.
// =====================================================================

function csaToggleVisibility(id) { 
  var style = document.getElementById(id).style;
  if (style.display == "none") style.display = "inline"
  else style.display = "none";
}

// =====================================================================
// string printf(string value, int length)
//
// See http://markos.gaivo.net/blog/?p=63
// =====================================================================

function printf(S, L) {
  var nS = "";
  var tS = S.split("%s");
  if (tS.length != L.length+1) throw "Input error";
  for(var i=0; i<L.length; i++) nS += tS[i] + L[i];
  return nS + tS[tS.length-1];
}

// =====================================================================
// void csaPrintValues(void)
//
// Print common DOM variable values.
// =====================================================================

function csaPrintValues () {
  alert("location.hash: " + location.hash +
	"\nlocation.host: " + location.host +
	"\nlocation.hostname: " + location.hostname +
	"\nlocation.href: " + location.href +
	"\nlocation.pathname: " + location.pathname +
	"\nlocation.port: " + location.port +
	"\nlocation.protocol: " + location.protocol +
	"\nlocation.search: " + location.search +
	"\nlocation.target: " + location.target +
	"\ndocument.referrer: " + document.referrer +
	"\ndocument.location: " + document.location +
	"\ndocument.title: " + document.title +
	"\ndocument.lastmodified: " + document.lastmodified +
	"\nnavigator.appName: " + navigator.appName +
	"\nnavigator.appVersion: " + navigator.appVersion);
}

// =====================================================================
// void csaDumpObject(object obj, object parent)
//
// See:
// http://www.breakingpar.com/bkp/home.nsf/0/87256B280015193F87256BF8004D72D6
// =====================================================================

function csaDumpObject(obj, parent) {
   // Go through all the properties of the passed-in object
   for (var i in obj) {
      // if a parent (2nd parameter) was passed in, then use that to
      // build the message. Message includes i (the object's property name)
      // then the object's property value on a new line
      if (parent) { var msg = parent + "." + i + "\n" + obj[i]; } else { var msg = i + "\n" + obj[i]; }
      // Display the message. If the user clicks "OK", then continue. If they
      // click "CANCEL" then quit this level of recursion
      if (!confirm(msg)) { return; }
      // If this property (i) is an object, then recursively process the object
      if (typeof obj[i] == "object") {
         if (parent) { csaDumpObject(obj[i], parent + "." + i); } else { csaDumpObject(obj[i], i); }
      }
   }
}

// ====================================================================
// Initialization section.
// ====================================================================

// Namespace URI's.
_XMLNS_CSA = "http://www.linux.it/~carlos/csa/";
_XMLNS_RDF = "http://www.w3.org/1999/02/22-rdf-syntax-ns#";
_XMLNS_XSD = "http://www.w3.org/2000/10/XMLSchema#";
_XMLNS_DC = "http://purl.org/dc/elements/1.1/";
_XMLNS_CC = "http://web.resource.org/cc/";

_RDF = new RDF();				// Create RDF object

// ====================================================================
// End of csaMainlib.js
// ====================================================================
