# =====================================================================
# AWK functions for CSA.
#
# Original code (C) March 10, 2003, Peter van Eerten
# Source: http://www.turtle.dds.nl/b64dec.awk
#
# Modified for CSA by Carlo Strozzi, January 28, 2006
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _b64decode.awk,v 1.2 2006/03/10 21:36:17 carlo Exp $
# =====================================================================
# string _b64decode(string value)
#
# Take a base64-encoded string and decode it to its original value. 
# Being mawk(1) not 8-bit clean, the original unencode string should
# not contain values that fall outside the LOCALE charset.
# =====================================================================

function _b64decode(value,	base1,base2,base3,base4,\
				byte1,byte2,byte3,byte4,result) {

  result = ""

  while (length(value) > 0) {
	# Specify byte values
	base1 = substr(value, 1, 1)
	base2 = substr(value, 2, 1)
	base3 = substr(value, 3, 1)
	base4 = substr(value, 4, 1)
	# Now find numerical position in _BASE64 string
	byte1 = index(_BASE64, base1) - 1
	if (byte1 < 0) byte1 = 0
	byte2 = index(_BASE64, base2) - 1
	if (byte2 < 0) byte2 = 0
	byte3 = index(_BASE64, base3) - 1
	if (byte3 < 0) byte3 = 0
	byte4 = index(_BASE64, base4) - 1
	if (byte4 < 0) byte4 = 0
	# Reconstruct ASCII string
	result = result sprintf("%c", _lshift(_and(byte1, 63), 2) + _rshift(_and(byte2, 48), 4))
	result = result sprintf("%c", _lshift(_and(byte2, 15), 4) + _rshift(_and(byte3, 60), 2))
	result = result sprintf("%c", _lshift(_and(byte3, 3), 6) + byte4)
	# Decrease incoming string with 4
	value = substr(value, 5)
  }
  return result
}

