# =====================================================================
# AWK functions for CSA.
#
# Original code (C) March 6, 2003, Peter van Eerten
# Source: http://www.turtle.dds.nl/b64enc.awk
#
# Modified for CSA by Carlo Strozzi, January 28, 2006
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _b64encode.awk,v 1.1 2006/03/10 21:36:17 carlo Exp $
# =====================================================================
# string _b64encode(string value)
#
# Take a string and return its base64-encoded value. Being mawk(1) not
# 8-bit clean, the original string should not contain values that fall
# outside the LOCALE charset.
# =====================================================================

function _b64encode(value,	byte1,byte2,byte3,byte4,\
				base1,base2,base3,base4,result) {
  result = ""

  while (length(value) > 0) {
	# Specify byte values
	if (length(value) == 1){
		byte1 = _asc(substr(value, 1, 1))
		byte2 = 0
		byte3 = 0
	}
	if (length(value) == 2) {
		byte1 = _asc(substr(value, 1, 1))
		byte2 = _asc(substr(value, 2, 1))
		byte3 = 0
	}
	if (length(value) >= 3) {
		byte1 = _asc(substr(value, 1, 1))
		byte2 = _asc(substr(value, 2, 1))
		byte3 = _asc(substr(value, 3, 1))
	}
	# Create BASE64 values
	base1 = _rshift(byte1, 2)
	base2 = _lshift(_and(byte1, 3), 4) + _rshift(_and(byte2, 240), 4)
	base3 = _lshift(_and(byte2, 15), 2) + _rshift(_and(byte3, 192), 6)
	base4 = _and(byte3, 63)
	# Compose BASE64 string
	if (length(value) == 1) {
		result = result substr(_BASE64, base1 + 1, 1)
		result = result substr(_BASE64, base2 + 1, 1)
		result = result "=="
		value = ""
	}
	if (length(value) == 2) {
		result = result substr(_BASE64, base1 + 1, 1)
		result = result substr(_BASE64, base2 + 1, 1)
		result = result substr(_BASE64, base3 + 1, 1)
		result = result "="
		value = ""
	}
	if (length(value) >= 3) {
		result = result substr(_BASE64, base1 + 1, 1)
		result = result substr(_BASE64, base2 + 1, 1)
		result = result substr(_BASE64, base3 + 1, 1)
		result = result substr(_BASE64, base4 + 1, 1)
		value = substr(value, 4)
	}
  }
  return result
}

