# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001,2006 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _escape.awk,v 1.3 2006/03/10 21:36:17 carlo Exp $
# =====================================================================
# string _escape(string s)
#
# Escape AWK special characters ", \ and \n in a string that is to be
# eval'd again by AWK. Long input strings are split into 72-character
# chunks. This is because there is a bug in fin.c (file-input functions)
# of mawk 1.3.3, whereby long lines in a script file cause mawk to
# segfault. As of January 2004, this long-standing mawk bug has not
# yet been fixed.
# =====================================================================

function _escape(s,	len,i,buf,S) {

  len = length(s)			# account for the null string

  for (i=1; i <= len; i+=72) {

     buf = substr(s,i,72)

     # Escape backslashes first ...
     gsub(/\\/,"\\\\\\", buf)

     # ... then double-quotes and newlines.
     gsub(/"/, "\\\"", buf)
     gsub(/\n/, "\\n", buf)

     if (S == "") S = "\"" buf "\""
     else S = S "\\\n\"" buf "\""
  }

  if (S == "") return "\"\""		# account for the null string
  return S
}

