# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001,2006 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _formradio.awk,v 1.3 2006/03/10 21:36:17 carlo Exp $
# =====================================================================
# string _formradio(string name, string value, \
#			string label, boolean checked)
#
# Returns the proper HTML "radio" form fragment, based on the specified
# arguments. Warning: the "label" string is not automatically
# XML-encoded. If such an encoding is desired it is up to the calling
# program to do it before calling this function. Note that unlike a
# <select> block, radio elements may be scattered across the page, so
# for maximum flexibility this function only returns one element at
# a time rather than the whole block in one single call.
# =====================================================================

function _formradio(name,value,label,check,	fragment) {

  fragment = "<input type=\"radio\" name=\"" name "\""

  check += 0					# Cast to number.

  fragment = fragment " value=\"" value "\""

  if (check) fragment = fragment " checked=\"checked\""

  return fragment " />" label			# well-formed XHTML
}

