# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001,2006 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _isemail.awk,v 1.2 2006/03/10 21:36:17 carlo Exp $
# =====================================================================
# boolean _isemail(string s)
#
# Checks that 'string' is a valid E-Mail address. Returns non-zero if
# it isn't. Multiple addresses can be specified in 'string', by
# saparating them with a comma ','. Blanks and/or tabs surrounding the
# address separator are silently ignored.
# =====================================================================

function _isemail(string,	addr1,addr2) {

  gsub(/[ \t]*,[ \t]*/, ",", string)	# Strip empty separators.
  if(string == _NULL) return _EINVAL

  split(string, addr1, ",")

  for (addr2 in addr1) {
      if (addr1[addr2] !~ /^[-_=.a-zA-Z0-9]+@[-.a-zA-Z0-9]+$/)
		return _EINVAL
  }
}

