# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001,2006 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _xmldecode.awk,v 1.3 2006/03/10 21:36:17 carlo Exp $
# =====================================================================
# string _xmldecode(string s)
#
# Perform the inverse of _xmlencode(), with the exception that the \001
# hack cannot be reverted, not being it distinguishable from all other
# blanks.
# =====================================================================

function _xmldecode(string) {

   # single quote (MSIE 5/6 sends "&#39;" instead of "&apos;".
   if (!gsub(/&apos;/, "'", string)) gsub(/&#39;/, "'", string)

   gsub(/&quot;/, "\"", string)		# double quote
   gsub(/&lt;/, "<", string)		# Open tag
   gsub(/&gt;/, ">", string)		# Close tag
					# (some programs encode it too)
   gsub(/&amp;/, "\\&", string)		# Ampersand at last.

   return string
}

